#pragma once

#include <iostream>
#include <string.h>
#include <stdio.h>
#include <ctype.h>
#include <conio.h>
#include <math.h>
#include "..\gstuff\g.h"
using namespace std;

#define StrEqu(x,y) strcmp(x,y) == 0

namespace Postfix
{
	struct Var
	{
		char *szName;
		float fValue;
	};

	bool ConvertToPostfix(char *szTokens, G::Queue<char *> &qTokens);

	char GetOpPrecedence(char cOp1, char cOp2);

	bool EvaluatePostfix(G::Queue<char *> &qTokens, float &fResult);
	
	bool CreateTokenList(char **szTokens);
	
	bool AddVar(const char *szName, float fValue);
	bool AddVar(const char *szName, float fValue, Var **pVar);

	bool GetVar(const char *szName, float &fValue);

	bool FindVar(const char *szName, Var **pVar);
	
	int GetTokenType(const char *szToken);

	bool GetTokenValue(const char *szToken, float &fValue);

	bool IsWhiteSpace(const char *szText);

	int opTable[6][6] =
	{
		{0, 0, 1, 1, 1, 2},
		{0, 0, 1, 1, 1, 2},
		{2, 2, 0, 0, 1, 2},
		{2, 2, 0, 0, 1, 2},
		{2, 2, 2, 2, 0, 2},
		{1, 1, 1, 1, 1, 2},
	};
	G::Vector<Var> vVars(10);
	unsigned int iVarCount = 0;
}
// Operator table... Shows precedence
// 0 = Equal
// 1 = Lower
// 2 = Greater
// = has lower precedence then all other ops, execpt itself
/*
	   +  -  *  /  ^  =
	+  0  0  1  1  1  2
	-  0  0  1  1  1  2
	*  2  2  0  0  1  2
	/  2  2  0  0  1  2
	^  2  2  2  2  0  2
	=  1  1  1  1  1  2
*/