// gQueue class
#include "g.h"

template <class iTyp>
G::Queue<iTyp>::Queue()
{
	iSize = 0;
	head = NULL;
}

template <class iTyp>
G::Queue<iTyp>::Queue(const Queue<iTyp> &q)
{
	G::gQueueNode<iTyp> *node = NULL;
	G::gQueueNode<iTyp> *newnode = NULL;
	head = NULL;

	if (q.iSize)
	{
		node = q.head;
		do
		{
			newnode = AddNode();
			newnode->item = node->item;
			node = node->next;
		} while (node != q.head);
	}
	iSize = q.iSize;
}

template <class iTyp>
G::Queue<iTyp>::~Queue()
{
	//Delete all members of the queue
	flush();
}

template <class iTyp>
int G::Queue<iTyp>::size()
{
	return iSize;
}

template <class iTyp>
void G::Queue<iTyp>::give(const iTyp i)
{
	gQueueNode<iTyp> *node = AddNode();
	node->item = i;
}

template <class iTyp>
bool G::Queue<iTyp>::take(iTyp &i)
{
	gQueueNode<iTyp> *node;
	if (head == NULL)
	{
		return false;
	}
	else if (head != head->next)
	{
		head->next->prev = head->prev;
		head->prev->next = head->next;
		node = head;
		i = node->item;
		head = head->next;
		delete node;
	}
	else {
		i = head->item;
		delete head;
		head = NULL;
	}
	iSize--;
	return true;
}

template <class iTyp>
void G::Queue<iTyp>::flush()
{
	gQueueNode<iTyp> *node;
	gQueueNode<iTyp> *nextnode;
	gQueueNode<iTyp> *temp;
	if (head != NULL)
	{
		node = head;
		temp = head;
		while (node != temp)
		{
			nextnode = node->next;
			delete node;
			node = nextnode;
		}
	}
}

template <class iTyp>
bool G::Queue<iTyp>::peek(iTyp &i)
{
	if (size == 0)
		return false;

	i = head->item;
	return true;
}

template <class iTyp>
G::gQueueNode<iTyp> *G::Queue<iTyp>::AddNode()
{
	gQueueNode<iTyp> *node = new gQueueNode<iTyp>;
	if (head != NULL)
	{
		node->next = head;
		head->prev->next = node;
		node->prev = head->prev;
		head->prev = node;
	}
	else
	{
		head = node;
		node->next = head;
		node->prev = head;
	}
	iSize++;
	return node;
}