// G::Stuff
// quicksort is broken

template <class iTyp>
G::Vector<iTyp> G::Stuff::Sort(G::Vector<iTyp> vList, int (*CompareFunction)(iTyp, iTyp))
{
	Vector<iTyp> vNewList(vList);
	
	Sort(vNewList, CompareFunction, 0, vNewList.size()-1);
	return vNewList;
}
template <class iTyp>
G::Vector<iTyp> G::Stuff::Sort(G::Vector<iTyp> vList)
{
	Vector<iTyp> vNewList(vList);
	
	Sort(vNewList, 0, vNewList.size()-1);
	return vNewList;
}

template <class iTyp>
void G::Stuff::Sort(G::Vector<iTyp> &vList, int (*CompareFunction)(iTyp, iTyp), 
			unsigned int iBegin, unsigned int iEnd)
{
	if (iBegin < iEnd)
	{
		unsigned int mid = Partition(vList, CompareFunction, iBegin, iEnd);
		Sort(vList, CompareFunction, iBegin, mid);
		Sort(vList, CompareFunction, mid+1, iEnd);
	}
}
template <class iTyp>
void G::Stuff::Sort(G::Vector<iTyp> &vList, 
			unsigned int iBegin, unsigned int iEnd)
{
	if (iEnd > iBegin)
	{
		unsigned int mid = Partition(vList, iBegin, iEnd);
		Sort(vList, iBegin, mid);
		Sort(vList, mid+1, iEnd);
	}
}

template <class iTyp>
unsigned int G::Stuff::Partition(G::Vector<iTyp> &vList, int (*CompareFunction)(iTyp, iTyp),
						 unsigned int iBegin, unsigned int iEnd)
{
	iTyp pivot = vList[(iEnd + iBegin) / 2];

	/*unsigned int iLeft = iBegin-1;
	unsigned int iRight = iEnd+1;*/

	unsigned int iLeft = iBegin;
	unsigned int iRight = iEnd;

	iTyp temp;

	for (;;)
	{
/*		do
		{
			iRight--;
		} while ((CompareFunction(vList[iRight], pivot) > 0));
		do
		{
			iLeft++;
		} while ((CompareFunction(vList[iLeft], pivot) < 0));
*/
		while (CompareFunction(vList[iRight], pivot) > 0)
			iRight--;

		while (CompareFunction(vList[iLeft], pivot) < 0)
			iLeft++;


		if (iLeft < iRight)
		{
			temp = vList[iLeft];
			vList[iLeft] = vList[iRight];
			vList[iRight] = temp;
			iRight--;
			iLeft++;
		}
		else
			return iRight;
	}
}

template <class iTyp>
unsigned int G::Stuff::Partition(G::Vector<iTyp> &vList,
						 unsigned int iBegin, unsigned int iEnd)
{
	iTyp pivot = vList[(iEnd + iBegin) / 2];

	/*unsigned int iLeft = iBegin-1;
	unsigned int iRight = iEnd+1;*/

	unsigned int iLeft = iBegin;
	unsigned int iRight = iEnd;

	iTyp temp;

	for (;;)
	{
	/*	do
		{
			iRight--;
		} while (vList[iRight] > pivot);
		do
		{
			iLeft++;
		} while (vList[iLeft] < pivot);
	*/
		while(vList[iRight] > pivot)
			iRight--;
		while (vList[iLeft] < pivot)
			iLeft++;


		if (iLeft < iRight)
		{
			temp = vList[iLeft];
			vList[iLeft] = vList[iRight];
			vList[iRight] = temp;
			iRight--;
			iLeft++;
		}
		else
			return iRight;
	}
}

template <class iTyp>
void G::Stuff::BubbleSort(G::Vector<iTyp> &vList, int (*CompareFunction)(iTyp, iTyp),
						  unsigned int iBegin, unsigned int iEnd)
{
	iTyp temp;

	for (unsigned int x = iBegin; x < iEnd; x++)
	{
		for (unsigned int y = iBegin; y < iEnd - x; y++)
		{
			if (CompareFunction(vList[y], vList[y+1]) > 0)
			{
				temp = vList[y];
				vList[y] = vList[y+1];
				vList[y+1] = temp;
			}
		}
	}
}

template <class iTyp>
void G::Stuff::BubbleSort(G::Vector<iTyp> &vList, unsigned int iBegin, unsigned int iEnd)
{
	iTyp temp;

	for (unsigned int x = iBegin; x < iEnd; x++)
	{
		for (unsigned int y = iBegin; y < iEnd - x; y++)
		{
			if (vList[y] > vList[y+1])
			{
				temp = vList[y];
				vList[y] = vList[y+1];
				vList[y+1] = temp;
			}
		}
	}
}

template <class iTyp>
signed int G::Stuff::Search(G::Vector<iTyp> vList, iTyp find, int (*CompareFunction)(iTyp, iTyp))
{
	return Search(vList, find, CompareFunction, 0, vList.size()-1);
}

template <class iTyp>
signed int G::Stuff::Search(G::Vector<iTyp> vList, iTyp find)
{
	return Search(vList, find, 0, vList.size()-1);
}

template <class iTyp>
signed int G::Stuff::Search(G::Vector<iTyp> vList, iTyp find, int (*CompareFunction)(iTyp, iTyp), unsigned int iBegin, unsigned int iEnd)
{
	if (iBegin > iEnd)
		return -1;
	
	unsigned int iMid = (iBegin + iEnd) / 2;

	if (CompareFunction(vList[iMid], find) == 0)
		return iMid;

	else if (CompareFunction(vList[iMid], find) > 0)
		return Search(vList, find, CompareFunction, iBegin, iMid-1);
	else
		return Search(vList, find, CompareFunction, iMid+1, iEnd);
}

template <class iTyp>
signed int G::Stuff::Search(G::Vector<iTyp> vList, iTyp find, unsigned int iBegin, unsigned int iEnd)
{
	if (iBegin > iEnd)
		return -1;
	
	unsigned int iMid = (iBegin + iEnd) / 2;

	if (vList[iMid] == find)
		return iMid;

	else if (vList[iMid] > find)
		return Search(vList, find, iBegin, iMid-1);
	else
		return Search(vList, find, iMid+1, iEnd);
}

template <class iTyp>
bool G::Stuff::Reverse(G::Vector<iTyp> vList, G::Vector<iTyp> &vNewList)
{
	vNewList.redim(vList.size());
	unsigned int i = 0;
	
	for (unsigned int x = vList.size()-1; x >= 0; x--)
	{
		vNewList[i] = vList[x];
		i++;
		if (x == 0) break;
	}
	return true;
}
template <class iTyp>
bool G::Stuff::Reverse(G::Vector<iTyp> &vList)
{
	unsigned int i = 0;
	iTyp temp;

	for (unsigned int x = vList.size()-1; x > (vList.size()-1)/2; x--)
	{
		if (i == x) break;
		temp = vList[x];
		vList[x] = vList[i];
		vList[i] = temp;
		i++;
	}
	return true;
}