// Matt's gVector class
// Riight...
template<class iTyp>
G::Vector<iTyp>::Vector() {
	mySize = 0;
	myList = NULL;
}

template <class iTyp>
G::Vector<iTyp>::Vector(int size) {
	mySize = size;
	myList = new iTyp[size];
}

template <class iTyp>
G::Vector<iTyp>::Vector(int size, iTyp val) {
	mySize = size;
	myList = new iTyp[size];
	for (int x = 0; x < size; x++) {
		myList[x] = val;
	}
}

template <class iTyp>
G::Vector<iTyp>::Vector(const Vector<iTyp> &v) {
	mySize = v.mySize;
	myList = new iTyp[mySize];

	for (int x = 0; x < mySize; x++) {
		myList[x] = v.myList[x];
	}
}

template <class iTyp> 
G::Vector<iTyp>::Vector(int size, const iTyp ary[]) {
	mySize = size;
	myList = new iTyp[mySize];
	
	for (int x = 0; x < mySize; x++) {
		myList[x] = ary[x];
	}
}

template <class iTyp>
G::Vector<iTyp>::~Vector() {
	delete[] myList;
}

template <class iTyp>
const G::Vector<iTyp> & G::Vector<iTyp>::operator =(const Vector<iTyp> &v) {
	if (this != &v) {
		delete[] myList;
		mySize = v.mySize;
		myList = new iTyp[mySize];

		for (int x = 0; x < mySize; x++) {
			myList[x] = v.myList[x];
		}
	}
	
	return *this;
}

template <class iTyp>
int G::Vector<iTyp>::size() const {
	return mySize;
}

template <class iTyp>
const iTyp & G::Vector<iTyp>::operator [](int i) const {
	if (i > mySize-1)
		i = mySize-1;

	return myList[i];
}

template <class iTyp>
iTyp & G::Vector<iTyp>::operator [](int i) {
	if (i > mySize-1)
		i = mySize-1;

	return myList[i];
}

template <class iTyp>
void G::Vector<iTyp>::redim(int iSize) {
	delete[] myList;
	mySize = iSize;
	myList = new iTyp[mySize];
}

template <class iTyp>
void G::Vector<iTyp>::redimp(int iSize) {
	iTyp *nList = new iTyp[iSize];
	for (int x = 0; ((x < iSize) && (x < mySize)); x++) {
		nList[x] = myList[x];
	}
	mySize = iSize;
	delete[] myList;
	myList = nList;
}

template <class iTyp>
void G::Vector<iTyp>::push(const iTyp item)
{
	redimp(mySize + 1);
	myList[mySize - 1] = item;
}

template <class iTyp>
void G::Vector<iTyp>::pop(iTyp &item)
{
	item = myList[mySize-1];
	if (mySize > 1)
		redimp(mySize-1);
	else
	{	
		delete[] myList;
		mySize = 0;
	}
}
